diff --git a/subprojects/core/src/main/groovy/org/gradle/execution/DefaultTaskGraphExecuter.java b/subprojects/core/src/main/groovy/org/gradle/execution/DefaultTaskGraphExecuter.java
index 32ac012..105d7b6 100644
--- a/subprojects/core/src/main/groovy/org/gradle/execution/DefaultTaskGraphExecuter.java
+++ b/subprojects/core/src/main/groovy/org/gradle/execution/DefaultTaskGraphExecuter.java
@@ -17,6 +17,17 @@
 package org.gradle.execution;
 
 import groovy.lang.Closure;
+
+import java.util.ArrayList;
+import java.util.Collection;
+import java.util.Collections;
+import java.util.HashSet;
+import java.util.LinkedHashMap;
+import java.util.List;
+import java.util.Map;
+import java.util.Set;
+import java.util.TreeSet;
+
 import org.gradle.api.CircularReferenceException;
 import org.gradle.api.Task;
 import org.gradle.api.execution.TaskExecutionGraphListener;
@@ -31,8 +42,6 @@ import org.gradle.util.Clock;
 import org.slf4j.Logger;
 import org.slf4j.LoggerFactory;
 
-import java.util.*;
-
 /**
  * @author Hans Dockter
  */
@@ -114,8 +123,10 @@ public class DefaultTaskGraphExecuter implements TaskGraphExecuter {
             if (visiting.add(task)) {
                 // Have not seen this task before - add its dependencies to the head of the queue and leave this
                 // task in the queue
-                Set<Task> dependsOnTasks = new TreeSet<Task>(Collections.reverseOrder());
-                dependsOnTasks.addAll(context.getDependencies(task));
+            	List<Task> dependsOnTasks = new ArrayList<Task>();
+            	dependsOnTasks.addAll(context.getDependencies(task));
+            	Collections.reverse(dependsOnTasks);
+            	
                 for (Task dependsOnTask : dependsOnTasks) {
                     if (visiting.contains(dependsOnTask)) {
                         throw new CircularReferenceException(String.format(
